<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

function wybmv_builder($params, $content) {
    extract( shortcode_atts( 
        array( 
            'shortcode_alignment'           => '',
            'title'                         => '',
            'show_subtitle'                 => '',
            'subtitle'                      => '',
            'button_yes'                    => '',
            'button_no'                     => '',
            'modal_title_yes'               => '',
            'modal_title_no'                => '',
            'modal_paragraph_yes'           => '',
            'modal_paragraph_no'            => '',
            'modal_no_btn_switch'           => '',
            'modal_yes_btn_switch'          => '',
            'image_yes'                     => '',
            'image_no'                      => '',
            'title_color'                   => '',
            'button_txt_color_yes'          => '',
            'button_txt_color_no'           => '',
            'button_yes_bg_color'           => '',
            'button_no_bg_color'            => '',
            'modal_title_color'             => '',
            'modal_txt_color'               => '',
            'modal_width'                   => '',
            'modal_yes_btn_switch'          => '',
            'modal_no_btn_switch'           => '',
            'modal_button_no'               => '',
            'modal_button_yes'              => '',
            'modal_button_no_phone'         => '',
            'modal_button_yes_phone'        => '',
            'modal_button_yes_mail'         => '',
            'modal_button_yes_subject'      => '',
            'modal_button_yes_body'         => '',
            'modal_button_no_mail'          => '',
            'modal_button_no_subject'       => '',
            'modal_button_no_body'          => '',
            'modal_button_yes_txt_color'    => '',
            'modal_button_no_txt_color'     => '',
            'modal_button_yes_bg_color'     => '',
            'modal_button_no_bg_color'      => '',

        ), $params ) ); 

        // JS
        wp_enqueue_script( 'wybmv-custom', plugins_url( 'assets/js/custom.js', __FILE__ ), array(), '1.0.0', 'all' );

        ob_start();
        
        $yes_data = uniqid('yes-data-');
        $no_data = uniqid('no-data-');   
        $popup_id = uniqid('wybmv-popup-');   
        $button_no_version = '';
        
        if ($shortcode_alignment == 'centered') {
            $alignment = 'centered';
        } elseif ($shortcode_alignment == 'left') {
            $alignment = 'left';
        } elseif ($shortcode_alignment == 'right') {
            $alignment = 'right';
        }


        ?>
        <div class="wybmv-container <?php echo esc_html($alignment); ?>">
            <h2 class="wybmv-title"><?php echo esc_html($title); ?></h2>
            <?php if($show_subtitle == 'yes') { ?>
                <p class="wybmv-subtitle"><?php echo esc_html($subtitle); ?></p>
            <?php } ?>
            <button class="wybmv-button wybmv-yes wybmv-toggle-popup-button" data-popup-id="<?php echo esc_attr($popup_id); ?>" data-value="<?php echo esc_attr($yes_data); ?>">
                <?php echo $button_yes;?></button>
            <button class="wybmv-button wybmv-no wybmv-toggle-popup-button" data-popup-id="<?php echo esc_attr($popup_id); ?>" data-value="<?php echo esc_attr($no_data); ?>"><?php echo $button_no;?></button>
            <div class="wybmv-popup" id="<?php echo esc_attr($popup_id); ?>" data-active-option="">
                <div class="wybmv-overlay"></div>
                <div class="wybmv-content wybmv-modal-width">
                    <div class="close-btn" data-popup-id="<?php echo esc_attr($popup_id); ?>">&times;</div>
                    <div class="wybmv-content-section wybmv-<?php echo esc_attr($yes_data); ?>-content">
                        <div class="wybmv-image-wrapper">
                            <img src="<?php echo esc_url($image_yes);?>" alt="<?php echo esc_attr($yes_data); ?>" />
                        </div>
                        <h2 class="wybmv-modal-title"><?php echo esc_html($modal_title_yes);?></h2>
                        <p class="wybmv-modal-paragraph"><?php echo esc_html($modal_paragraph_yes);?></p>
                        <?php if($modal_yes_btn_switch == 'call') { ?>
                            <a class="wybmv-modal-button wybmv-yes wybmv-toggle-popup-button" href="tel:<?php echo esc_html($modal_button_yes_phone); ?>"><?php echo esc_html($modal_button_yes); ?></a>
                        <?php } elseif ($modal_yes_btn_switch == 'mail') { ?>
                            <a class="wybmv-modal-button wybmv-yes wybmv-toggle-popup-button" href="mailto:<?php echo esc_attr($modal_button_yes_mail); ?>?&subject=<?php echo esc_attr($modal_button_yes_subject); ?>&body=<?php echo esc_attr($modal_button_yes_body); ?>"><?php echo esc_html($modal_button_yes); ?></a>
                       <?php } ?>    
                    </div>
                    <div class="wybmv-content-section wybmv-<?php echo esc_attr($no_data); ?>-content">
                        <div class="wybmv-image-wrapper">
                            <img src="<?php echo esc_url($image_no);?>" alt="<?php echo esc_attr($no_data); ?>" />
                        </div>
                        <h2 class="wybmv-modal-title"><?php echo esc_html($modal_title_no); ?></h2>
                        <p class="wybmv-modal-paragraph"><?php echo esc_html($modal_paragraph_no); ?></p>
                        <?php if($modal_no_btn_switch == 'call') { ?>
                            <a class="wybmv-modal-button wybmv-no wybmv-toggle-popup-button" href="tel:<?php echo esc_html($modal_button_no_phone); ?>"><?php echo esc_html($modal_button_no); ?></a>
                        <?php } elseif ($modal_no_btn_switch == 'mail') { ?>
                            <a class="wybmv-modal-button wybmv-no wybmv-toggle-popup-button" href="mailto:<?php echo esc_attr($modal_button_no_mail); ?>?&subject=<?php echo esc_attr($modal_button_no_subject); ?>&body=<?php echo esc_attr($modal_button_no_body); ?>"><?php echo esc_html($modal_button_no); ?></a>
                       <?php } ?> 
                    </div>
                </div>
            </div>
        </div>
        <?php
        return ob_get_clean();
}
add_shortcode('wybmv-builder-shortcode', 'wybmv_builder');


if ( class_exists('Elementor\Core\Admin\Admin') ) {
    class WYBMV_Elementor_Widgets {

        protected static $instance = null;

        public static function get_instance() {
            if ( ! isset( static::$instance ) ) {
                static::$instance = new static;
            }

            return static::$instance;
        }

        protected function __construct() {
            require_once('elementor.php');

            add_action( 'elementor/widgets/widgets_registered', [ $this, 'register_widgets' ] );
        }

        public function register_widgets() {
            \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor\WYBMV_Widget() );
        }

    }

    // Elementor Init
    add_action( 'init', 'wybmv_elementor_init' );
    function wybmv_elementor_init() {
        WYBMV_Elementor_Widgets::get_instance();
    }

    // Elementor Widgets Category
    function wybmv_widget_categories( $elements_manager ) {
        $elements_manager->add_category(
            'modeltheme-widgets',
            [
                'title' => esc_html__( 'Modeltheme Widgets', 'wybmv' ),
                'icon' => 'fas fa-plug',
            ]
        );
    }
    add_action( 'elementor/elements/categories_registered', 'wybmv_widget_categories' );
}
